=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2008-12-09 18:56:09 +0000
+++ client/drizzletest.cc	2008-12-10 02:09:33 +0000
@@ -1957,7 +1957,7 @@
   /* Alloc/realloc data for str_val in dest */
   if (dest->alloced_len < src->alloced_len)
   {
-    char *tmpptr= realloc(dest->str_val, src->alloced_len);
+    char *tmpptr= (char *)realloc(dest->str_val, src->alloced_len);
     if (tmpptr == NULL)
       die("Out of memory");
     dest->str_val= tmpptr;

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2008-12-02 23:01:32 +0000
+++ drizzled/Makefile.am	2008-12-10 02:09:33 +0000
@@ -55,6 +55,7 @@
 		base.h \
 		cached_item.h \
 		client_settings.h \
+		current_session.h \
 		common.h \
 		comp_creator.h \
 		configvar.h \
@@ -193,6 +194,7 @@
 		cached_item.cc \
 		comp_creator.cc \
 		configvar.cc \
+		current_session.cc \
 		db.cc \
 		discover.cc \
 		drizzled.cc \

=== modified file 'drizzled/common_includes.h'
--- drizzled/common_includes.h	2008-12-06 19:42:46 +0000
+++ drizzled/common_includes.h	2008-12-10 02:09:33 +0000
@@ -56,6 +56,7 @@
 #include <drizzled/sql_plugin.h>
 
 
+
 /**
  * @TODO Move the following into a drizzled.h header?
  *
@@ -63,17 +64,7 @@
  * and that are used only in the server should be separated out into
  * a drizzled.h header file -- JRP
  */
-
-
 extern const CHARSET_INFO *system_charset_info, *files_charset_info ;
 extern const CHARSET_INFO *national_charset_info, *table_alias_charset;
 
-extern pthread_key_t THR_Session;
-inline Session *_current_session(void)
-{
-  return (Session *)pthread_getspecific(THR_Session);
-}
-#define current_session _current_session()
-
-
 #endif /* DRIZZLE_SERVER_COMMON_INCLUDES_H */

=== added file 'drizzled/current_session.cc'
--- drizzled/current_session.cc	1970-01-01 00:00:00 +0000
+++ drizzled/current_session.cc	2008-12-10 02:09:33 +0000
@@ -0,0 +1,44 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
+
+#include <pthread.h>
+
+extern pthread_key_t THR_Session;
+extern pthread_key_t THR_Mem_root;
+
+Session *_current_session(void)
+{
+  return static_cast<Session *>(pthread_getspecific(THR_Session));
+}
+
+
+MEM_ROOT *current_mem_root(void)
+{
+  return *(static_cast<MEM_ROOT **>(pthread_getspecific(THR_Mem_root)));
+}
+
+
+MEM_ROOT **current_mem_root_ptr(void)
+{
+  return static_cast<MEM_ROOT **>(pthread_getspecific(THR_Mem_root));
+}
+

=== added file 'drizzled/current_session.h'
--- drizzled/current_session.h	1970-01-01 00:00:00 +0000
+++ drizzled/current_session.h	2008-12-10 02:09:33 +0000
@@ -0,0 +1,31 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef DRIZZLED_CURRENT_SESSION_H
+#define DRIZZLED_CURRENT_SESSION_H
+
+class Session;
+
+Session *_current_session(void);
+#define current_session _current_session()
+MEM_ROOT *current_mem_root(void);
+MEM_ROOT **current_mem_root_ptr(void);
+
+#endif /* DRIZZLED_CURRENT_SESSION_H */

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-12-09 04:45:44 +0000
+++ drizzled/drizzled.cc	2008-12-10 02:09:33 +0000
@@ -427,7 +427,7 @@
 
 /* Thread specific variables */
 
-pthread_key_t THR_MALLOC;
+pthread_key_t THR_Mem_root;
 pthread_key_t THR_Session;
 pthread_mutex_t LOCK_drizzle_create_db, LOCK_open, LOCK_thread_count,
                 LOCK_status,
@@ -2069,7 +2069,7 @@
   }
 
   if (pthread_key_create(&THR_Session,NULL) ||
-      pthread_key_create(&THR_MALLOC,NULL))
+      pthread_key_create(&THR_Mem_root,NULL))
   {
     sql_print_error(_("Can't create thread-keys"));
     return 1;

=== modified file 'drizzled/functions/decimal_typecast.cc'
--- drizzled/functions/decimal_typecast.cc	2008-10-23 02:48:56 +0000
+++ drizzled/functions/decimal_typecast.cc	2008-12-10 02:09:33 +0000
@@ -21,6 +21,7 @@
 #include CSTDINT_H
 #include <drizzled/functions/decimal_typecast.h>
 #include <drizzled/error.h>
+#include <drizzled/current_session.h>
 
 
 String *Item_decimal_typecast::val_str(String *str)

=== modified file 'drizzled/functions/signed.cc'
--- drizzled/functions/signed.cc	2008-12-06 19:42:46 +0000
+++ drizzled/functions/signed.cc	2008-12-10 02:09:33 +0000
@@ -20,6 +20,7 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/error.h>
+#include <drizzled/current_session.h>
 #include <drizzled/functions/signed.h>
 
 void Item_func_signed::print(String *str, enum_query_type query_type)

=== modified file 'drizzled/functions/time/make_datetime_with_warn.cc'
--- drizzled/functions/time/make_datetime_with_warn.cc	2008-11-12 20:15:41 +0000
+++ drizzled/functions/time/make_datetime_with_warn.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/functions/time/make_datetime_with_warn.h>
 

=== modified file 'drizzled/functions/time/make_time_with_warn.cc'
--- drizzled/functions/time/make_time_with_warn.cc	2008-11-12 22:33:35 +0000
+++ drizzled/functions/time/make_time_with_warn.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/functions/time/make_time_with_warn.h>
 

=== modified file 'drizzled/functions/time/maketime.cc'
--- drizzled/functions/time/maketime.cc	2008-12-06 19:42:46 +0000
+++ drizzled/functions/time/maketime.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/functions/time/maketime.h>
 #include <drizzled/functions/time/make_time_with_warn.h>

=== modified file 'drizzled/functions/time/sec_to_time.cc'
--- drizzled/functions/time/sec_to_time.cc	2008-12-06 19:42:46 +0000
+++ drizzled/functions/time/sec_to_time.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/functions/time/sec_to_time.h>
 

=== modified file 'drizzled/functions/time/str_to_date.cc'
--- drizzled/functions/time/str_to_date.cc	2008-12-06 19:42:46 +0000
+++ drizzled/functions/time/str_to_date.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/sql_locale.h>
 #include <drizzled/error.h>

=== modified file 'drizzled/functions/time/typecast.cc'
--- drizzled/functions/time/typecast.cc	2008-12-06 19:42:46 +0000
+++ drizzled/functions/time/typecast.cc	2008-12-10 02:09:33 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include CSTDINT_H
 #include <drizzled/error.h>
 #include <drizzled/functions/time/typecast.h>

=== modified file 'drizzled/functions/unsigned.cc'
--- drizzled/functions/unsigned.cc	2008-10-23 03:41:40 +0000
+++ drizzled/functions/unsigned.cc	2008-12-10 02:09:33 +0000
@@ -20,6 +20,7 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/unsigned.h>
+#include <drizzled/current_session.h>
 #include <drizzled/error.h>
 
 void Item_func_unsigned::print(String *str, enum_query_type query_type)

=== modified file 'drizzled/item/cmpfunc.h'
--- drizzled/item/cmpfunc.h	2008-12-06 19:42:46 +0000
+++ drizzled/item/cmpfunc.h	2008-12-10 02:09:33 +0000
@@ -27,6 +27,7 @@
 #include <drizzled/item/sum.h>
 #include <drizzled/functions/int.h>
 #include <drizzled/functions/numhybrid.h>
+#include <drizzled/session.h>
 
 
 extern Item_result item_cmp_type(Item_result a,Item_result b);

=== modified file 'drizzled/item/ident.cc'
--- drizzled/item/ident.cc	2008-12-06 19:56:31 +0000
+++ drizzled/item/ident.cc	2008-12-10 02:09:33 +0000
@@ -21,6 +21,7 @@
 #include CSTDINT_H
 #include <drizzled/show.h>
 #include <drizzled/table.h>
+#include <drizzled/current_session.h>
 #include <drizzled/item/ident.h>
 
 const uint32_t NO_CACHED_FIELD_INDEX= UINT32_MAX;

=== modified file 'drizzled/my_decimal.cc'
--- drizzled/my_decimal.cc	2008-10-23 02:48:56 +0000
+++ drizzled/my_decimal.cc	2008-12-10 02:09:33 +0000
@@ -14,6 +14,7 @@
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include <time.h>
 #include <drizzled/error.h>
 

=== modified file 'drizzled/server_includes.h'
--- drizzled/server_includes.h	2008-12-06 22:33:19 +0000
+++ drizzled/server_includes.h	2008-12-10 02:09:33 +0000
@@ -48,6 +48,8 @@
 #include <string>
 #include <bitset>
 
+
+
 typedef class st_select_lex SELECT_LEX;
 typedef struct st_mysql_lock DRIZZLE_LOCK;
 typedef struct st_ha_create_information HA_CREATE_INFO;
@@ -196,7 +198,6 @@
 extern DRIZZLE_BIN_LOG drizzle_bin_log;
 extern TableList general_log, slow_log;
 extern FILE *stderror_file;
-extern pthread_key_t THR_MALLOC;
 extern pthread_mutex_t LOCK_drizzle_create_db,LOCK_open, LOCK_lock_db,
        LOCK_thread_count,LOCK_user_locks, LOCK_status,
        LOCK_error_log, LOCK_uuid_generator,

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2008-12-09 05:50:07 +0000
+++ drizzled/session.cc	2008-12-10 02:09:33 +0000
@@ -46,6 +46,8 @@
 char empty_c_string[1]= {0};    /* used for not defined db */
 
 const char * const Session::DEFAULT_WHERE= "field list";
+extern pthread_key_t THR_Session;
+extern pthread_key_t THR_Mem_root;
 
 
 /*****************************************************************************
@@ -64,6 +66,7 @@
 template class List_iterator<Alter_column>;
 #endif
 
+
 /****************************************************************************
 ** User variables
 ****************************************************************************/
@@ -778,6 +781,7 @@
   }
 
   free_root(&main_mem_root, MYF(0));
+  pthread_setspecific(THR_Session,  0);
   return;
 }
 
@@ -894,7 +898,7 @@
   assert(thread_stack);
 
   if (pthread_setspecific(THR_Session,  this) ||
-      pthread_setspecific(THR_MALLOC, &mem_root))
+      pthread_setspecific(THR_Mem_root, &mem_root))
     return 1;
   mysys_var=my_thread_var;
   /*

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2008-12-09 05:50:07 +0000
+++ drizzled/session.h	2008-12-10 02:09:33 +0000
@@ -33,6 +33,7 @@
 #include <drizzled/ha_trx_info.h>
 #include <mysys/my_tree.h>
 #include <drizzled/handler.h>
+#include <drizzled/current_session.h>
 #include <drizzled/sql_error.h>
 #include <bitset>
 
@@ -1581,6 +1582,7 @@
 };
 
 
+
 /** A short cut for session->main_da.set_ok_status(). */
 
 inline void

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2008-12-09 05:50:07 +0000
+++ drizzled/sql_base.cc	2008-12-10 02:09:33 +0000
@@ -6253,7 +6253,6 @@
     my_dirend(dirp);
   }
   delete session;
-  pthread_setspecific(THR_Session,  0);
   return(0);
 }
 

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2008-12-08 10:34:49 +0000
+++ drizzled/table.cc	2008-12-10 02:09:33 +0000
@@ -397,7 +397,7 @@
   /* No handling of text based files yet */
   if (table_type == 1)
   {
-    root_ptr= (MEM_ROOT **)pthread_getspecific(THR_MALLOC);
+    root_ptr= current_mem_root_ptr();
     old_root= *root_ptr;
     *root_ptr= &share->mem_root;
     error= open_binary_frm(session, share, head, file);
@@ -1474,7 +1474,7 @@
   */
   MEM_ROOT **root_ptr, *old_root;
   Item *backup_free_list= session->free_list;
-  root_ptr= (MEM_ROOT **)pthread_getspecific(THR_MALLOC);
+  root_ptr= current_mem_root_ptr();
   old_root= *root_ptr;
   *root_ptr= &table->mem_root;
   session->free_list= NULL;

=== modified file 'drizzled/thr_malloc.cc'
--- drizzled/thr_malloc.cc	2008-11-29 00:09:36 +0000
+++ drizzled/thr_malloc.cc	2008-12-10 02:09:33 +0000
@@ -17,8 +17,10 @@
 /* Mallocs for used in threads */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/current_session.h>
 #include <drizzled/error.h>
 
+
 extern "C" {
   void sql_alloc_error_handler(void)
   {
@@ -35,7 +37,7 @@
 
 void *sql_alloc(size_t Size)
 {
-  MEM_ROOT *root= *(MEM_ROOT **)pthread_getspecific(THR_MALLOC);
+  MEM_ROOT *root= current_mem_root();
   return alloc_root(root,Size);
 }
 

=== modified file 'plugin/compress/compressudf.cc'
--- plugin/compress/compressudf.cc	2008-11-18 22:12:56 +0000
+++ plugin/compress/compressudf.cc	2008-12-10 02:09:33 +0000
@@ -19,6 +19,7 @@
 #include <drizzled/item/strfunc.h>
 #include <drizzled/error.h>
 #include <drizzled/sql_error.h>
+#include <drizzled/current_session.h>
 #include <zlib.h>
 
 class Item_func_compress: public Item_str_func

=== modified file 'storage/heap/ha_heap.cc'
--- storage/heap/ha_heap.cc	2008-12-07 22:57:38 +0000
+++ storage/heap/ha_heap.cc	2008-12-10 02:09:33 +0000
@@ -20,6 +20,7 @@
 #include <drizzled/error.h>
 #include <drizzled/table.h>
 #include <drizzled/session.h>
+#include <drizzled/current_session.h>
 #include <drizzled/field/timestamp.h>
 #include <drizzled/field/varstring.h>
 

=== modified file 'storage/innobase/drizzle/ha_innodb.cc'
--- storage/innobase/drizzle/ha_innodb.cc	2008-12-07 22:57:38 +0000
+++ storage/innobase/drizzle/ha_innodb.cc	2008-12-10 02:09:33 +0000
@@ -34,6 +34,7 @@
 #include <drizzled/field.h>
 #include <drizzled/log.h>
 #include <drizzled/session.h>
+#include <drizzled/current_session.h>
 #include <drizzled/table.h>
 #include <drizzled/field/blob.h>
 #include <drizzled/field/varstring.h>

